<template>
  <div class="app-container">

    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
<!--      <el-form-item label="使用场景" prop="useScene">-->
<!--        <el-input-->
<!--          v-model="queryParams.useScene"-->
<!--          placeholder="请输入使用场景"-->
<!--          clearable-->
<!--          @keyup.enter.native="handleQuery"-->
<!--        />-->
<!--      </el-form-item>-->
      <el-form-item label="使用场景" prop="useScene">
        <el-select v-model="queryParams.useScene" placeholder="请选择使用场景">
          <el-option
            v-for="item in options"
            :key="item.value"
            :label="item.label"
            :value="item.value">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="查询条件" prop="searchCondition">
        <el-input
          v-model="queryParams.searchCondition"
          placeholder="请输入元器件查询条件"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['biz:train:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['biz:train:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['biz:train:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="info"
          icon="el-icon-upload2"
          size="mini"
          @click="handleImport"
          v-hasPermi="['biz:train:import']"
        >训练数据集导入</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['biz:train:export']"
        >导出</el-button>
      </el-col >
      <el-col :span="1.5" >
        <el-button type="primary" size="mini" @click="mytrain">训练</el-button>

      </el-col>

      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="trainList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
<!--      <el-table-column label="编号" align="center" prop="id" />-->
      <el-table-column label="使用场景" align="center" prop="useScene" />
      <el-table-column label="查询条件" align="center" prop="searchCondition" />
      <el-table-column label="标准结果1" align="center" prop="result1" />
      <el-table-column label="标准结果2" align="center" prop="result2" />
      <el-table-column label="标准结果3" align="center" prop="result3" />
      <el-table-column label="标准结果4" align="center" prop="result4" />
      <el-table-column label="标准结果5" align="center" prop="result5" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['biz:train:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['biz:train:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"

      @pagination="getList"
    />

    <!-- 添加或修改训练集数据列对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="使用场景" prop="useScene">
          <el-input v-model="form.useScene" placeholder="请输入使用场景" />
        </el-form-item>
        <el-form-item label="查询条件" prop="searchCondition">
          <el-input v-model="form.searchCondition" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="标准结果1" prop="result1">
          <el-input v-model="form.result1" placeholder="请输入标准结果1" />
        </el-form-item>
        <el-form-item label="标准结果2" prop="result2">
          <el-input v-model="form.result2" placeholder="请输入标准结果2" />
        </el-form-item>
        <el-form-item label="标准结果3" prop="result3">
          <el-input v-model="form.result3" placeholder="请输入标准结果3" />
        </el-form-item>
        <el-form-item label="标准结果4" prop="result4">
          <el-input v-model="form.result4" placeholder="请输入标准结果4" />
        </el-form-item>
        <el-form-item label="标准结果5" prop="result5">
          <el-input v-model="form.result5" placeholder="请输入标准结果5" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 训练数据导入对话框 -->
    <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px">
      <el-upload
        ref="upload"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url + '?updateSupport=' + upload.updateSupport"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">
          将文件拖到此处，或
          <em>点击上传</em>
        </div>
        <div class="el-upload__tip" slot="tip">
          <el-checkbox v-model="upload.updateSupport" />是否更新已经存在的数据
          <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
        </div>
        <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">确 定</el-button>
        <el-button @click="upload.open = false">取 消</el-button>
      </div>
    </el-dialog>

    <el-dialog
      title="训练"
      :visible.sync="dialogVisible"
      width="20%"
      style="top:225px"

    >
      <div  align="center">
      <el-progress
        type="circle"
        :percentage="Progress"
        width="80"
        :status="progressStatus"
      ></el-progress>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listTrain, getTrain, delTrain, addTrain, updateTrain,getComponentIds,train } from "@/api/biz/train";
import { getToken } from "@/utils/auth";
import dayjs from "dayjs";
export default {
  name: "Train",
  data() {
    return {
      dialogVisible:false,
      Progress:0,
      // 导入参数
      upload: {
        // 是否显示弹出层（导入）
        open: false,
        // 弹出层标题（导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: { Authorization: "Bearer " + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/biz/train/importData"
      },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 训练集数据列表格数据
      trainList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        useScene: null,
        searchCondition: null,
        result1: null,
        result2: null,
        result3: null,
        result4: null,
        result5: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      options:[
        {
          value: '质量最优',
          label: '质量最优'
        }, {
          value: '成本最优',
          label: '成本最优'
        }, {
          value: '供货周期最优',
          label: '供货周期最优'
        }, {
          value: '供货量最优',
          label: '供货量最优'
        }
      ],

    };
  },
  created() {
    this.getList();
  },
  computed: {
    progressStatus() {
      return this.Progress === 100 ? 'success' : '';
    },
  },
  methods: {

    mytrain() {

      getComponentIds().then(response=>{
        let result;
        train().then(res=>{
          result = res

        })
        // 模拟进度变化，每0.1秒更新一次，共更新100次
        this.dialogVisible = true
        const intervalId = setInterval(() => {

          this.Progress++;
          // 如果进度达到100%，清除定时器
          if (this.Progress >= 100) {
            this.Progress = 0
            clearInterval(intervalId);
            this.dialogVisible = false

            if(result.code===200)
              this.$modal.msgSuccess(result.msg);
            else {
              this.$modal.msgError(result.msg);
            }
          }
        }, 100);
      })

    },
    /** 查询训练集数据列列表 */
    getList() {
      this.Progress = 0;
      this.loading = true;
      listTrain(this.queryParams).then(response => {
        this.trainList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        useScene: null,
        searchCondition: null,
        result1: null,
        result2: null,
        result3: null,
        result4: null,
        result5: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加训练集数据列";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getTrain(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改训练集数据列";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateTrain(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addTrain(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除训练集数据列编号为"' + ids + '"的数据项？').then(function() {
        return delTrain(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 下载模板操作 */
    importTemplate() {
      this.download('biz/train/importTemplate', {
      }, `train_dataset_template_${new Date().getTime()}.xlsx`)
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('biz/train/export', {
        ...this.queryParams
      }, `train_${new Date().getTime()}.xlsx`)
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = "训练数据集导入";
      this.upload.open = true;
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
      this.getList();
    },
// 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    }
  }
};
</script>
<style>

.el-checkbox__inner {
  border-color: #8492a6 !important;
}
.app-container {
  min-height: 100vh;
  background: radial-gradient(circle at 10% 20%, #3A71A8 0%, rgb(239, 249, 249) 90%);
}
</style>
